module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/index.ts":
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const typescript_1 = __webpack_require__(/*! ./typescript */ "./src/typescript/index.ts");
const server_core_1 = __webpack_require__(/*! @common-stack/server-core */ "@common-stack/server-core");
exports.default = new server_core_1.Feature(typescript_1.default);


/***/ }),

/***/ "./src/service/index.ts":
/*!******************************!*\
  !*** ./src/service/index.ts ***!
  \******************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(/*! ./javascript-service */ "./src/service/javascript-service.ts"));


/***/ }),

/***/ "./src/service/javascript-service.ts":
/*!*******************************************!*\
  !*** ./src/service/javascript-service.ts ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const inversify_1 = __webpack_require__(/*! inversify */ "inversify");
const lsp = __webpack_require__(/*! vscode-languageserver */ "vscode-languageserver");
const tsp_client_1 = __webpack_require__(/*! ./tsp-client */ "./src/service/tsp-client.ts");
const utils_1 = __webpack_require__(/*! ../utils */ "./src/utils/index.ts");
const language_core_1 = __webpack_require__(/*! @workbench-stack/language-core */ "@workbench-stack/language-core");
let JavascriptService = class JavascriptService {
    constructor() {
        this.openedDocumentUris = new Map();
        this.onInitialize = (params) => {
            console.log('The js/ts server is initialized.');
            this.initializeParams = params;
            this.tspClient = new tsp_client_1.TspClient({
                tsserverPath: 'tsserver',
                onEvent: event => { },
            });
            this.tspClient.start();
            return {
                capabilities: {
                    completionProvider: true,
                    definitionProvider: true,
                    documentFormattingProvider: true,
                    documentHighlightProvider: true,
                    documentSymbolProvider: true,
                    hoverProvider: true,
                    renameProvider: true,
                    referencesProvider: true,
                    workspaceSymbolProvider: false,
                    documentLinkProvider: false,
                },
            };
        };
        this.onDidOpenTextDocument = async (params) => {
            console.log('onDidOpenTextDocument js/ts');
            const path = language_core_1.uriToPath(params.textDocument.uri);
            const document = new language_core_1.TextDocument(params.textDocument);
            this.openedDocumentUris.set(params.textDocument.uri, document);
            this.tspClient.notify("open", {
                file: path,
                fileContent: params.textDocument.text,
            });
        };
        this.onDidChangeTextDocument = params => {
            console.log('onDidChangeTextDocument js/ts');
            const document = this.getOpenDocument(params.textDocument.uri);
            const changes = language_core_1.convertChangesRange(params.contentChanges);
            document.apply(changes, params.textDocument.version);
        };
        this.onDidCloseTextDocument = async (params) => {
            console.log('onDidCloseTextDocument js/ts');
            const path = language_core_1.uriToPath(params.textDocument.uri);
            this.openedDocumentUris.delete(params.textDocument.uri);
            this.tspClient.notify("close", { file: path });
        };
    }
    async onRename(params) {
        console.log('onRenameRequest js/ts', params);
        const path = language_core_1.uriToPath(params.textDocument.uri);
        const result = await this.tspClient.request("rename", {
            file: path,
            line: params.position.line + 1,
            offset: params.position.character + 1,
        });
        const workspaceEdit = {
            changes: {},
        };
        if (result.body.info.localizedErrorMessage) {
            return {
                rejectReason: result.body.info.localizedErrorMessage,
                edits: result.body.locs,
            };
        }
        if (!result.body || !result.body.info.canRename || result.body.locs.length === 0) {
            return workspaceEdit;
        }
        result.body.locs
            .forEach((spanGroup) => {
            const uri = language_core_1.pathToUri(spanGroup.file), textEdits = workspaceEdit.changes[uri] || (workspaceEdit.changes[uri] = []);
            spanGroup.locs.forEach((textSpan) => {
                textEdits.push({
                    newText: params.newName,
                    range: {
                        start: utils_1.toPosition(textSpan.start),
                        end: utils_1.toPosition(textSpan.end),
                    },
                });
            });
        });
        return workspaceEdit;
    }
    async onReferences(params) {
        console.log('onReferences js/ts');
        const path = language_core_1.uriToPath(params.textDocument.uri);
        try {
            const result = await this.tspClient.request("references", {
                file: path,
                line: params.position.line + 1,
                offset: params.position.character + 1,
            });
            console.log('result js/ts', result);
            if (!result.body) {
                return [];
            }
            return result.body.refs
                .map(fileSpan => utils_1.toLocation(fileSpan));
        }
        catch (err) {
            console.log('err', err);
            return [];
        }
    }
    async onHover(params) {
        console.log('onHover js/ts');
        const path = language_core_1.uriToPath(params.textDocument.uri);
        let result;
        try {
            result = await this.tspClient.request("quickinfo", {
                file: path,
                line: params.position.line + 1,
                offset: params.position.character + 1,
            });
            if (!result.body) {
                return {
                    contents: [],
                };
            }
            const range = {
                start: utils_1.toPosition(result.body.start),
                end: utils_1.toPosition(result.body.end),
            };
            const contents = [
                { language: 'typescript', value: result.body.displayString },
            ];
            if (result.body.documentation) {
                contents.push(result.body.documentation);
            }
            return {
                contents,
                range,
            };
        }
        catch (err) {
            console.log('err', err);
            return {
                contents: [],
            };
        }
    }
    async onDocumentSymbol(params) {
        console.log('onDocumentSymbol js/ts');
        const path = language_core_1.uriToPath(params.textDocument.uri);
        const response = await this.tspClient.request("navtree", {
            file: path,
        });
        console.log('response', response);
        if (!response.body) {
            return [];
        }
        const result = [];
        const collectSymbol = (element, parent, acceptor) => {
            const start = element.spans[0];
            const end = element.spans[element.spans.length - 1];
            if (start && end) {
                const symbol = lsp.SymbolInformation.create(element.text, utils_1.toSymbolKind(element.kind), { start: utils_1.toPosition(start.start), end: utils_1.toPosition(end.end) }, params.textDocument.uri, parent);
                acceptor(symbol);
            }
            if (element.childItems) {
                for (const child of element.childItems) {
                    collectSymbol(child, element.text, acceptor);
                }
            }
        };
        collectSymbol(response.body, undefined, sym => result.push(sym));
        return result.map(item => {
            if (!item.containerName) {
                item.containerName = '';
            }
            return item;
        });
    }
    async onDocumentHighlight(arg) {
        console.log('onDocumentHighlight js/ts');
        let response;
        try {
            response = await this.tspClient.request("documentHighlights", {
                file: language_core_1.uriToPath(arg.textDocument.uri),
                line: arg.position.line + 1,
                offset: arg.position.character + 1,
                filesToSearch: [language_core_1.uriToPath(arg.textDocument.uri)],
            });
        }
        catch (err) {
            return [];
        }
        if (!response.body) {
            return [];
        }
        const result = [];
        for (const item of response.body) {
            const highlights = utils_1.toDocumentHighlight(item);
            result.push(...highlights);
        }
        return result;
    }
    async onDocumentFormatting(params) {
        console.log('onDocumentFormatting js/ts');
        const path = language_core_1.uriToPath(params.textDocument.uri);
        let opts = Object.assign({}, params.options);
        if (!opts.convertTabsToSpaces) {
            opts.convertTabsToSpaces = params.options.insertSpaces;
        }
        const response = await this.tspClient.request("format", {
            file: path,
            line: 1,
            offset: 1,
            endLine: Number.MAX_SAFE_INTEGER,
            endOffset: Number.MAX_SAFE_INTEGER,
            options: {
                'tabSize': 4,
                'indentSize': 4,
                'newLineCharacter': '\n',
                'convertTabsToSpaces': false,
                'insertSpaceAfterCommaDelimiter': true,
                'insertSpaceAfterSemicolonInForStatements': true,
                'insertSpaceBeforeAndAfterBinaryOperators': true,
                'insertSpaceAfterKeywordsInControlFlowStatements': true,
                'insertSpaceAfterFunctionKeywordForAnonymousFunctions': true,
                'insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis': false,
                'insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets': false,
                'insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces': false,
                'insertSpaceBeforeFunctionParenthesis': false,
                'placeOpenBraceOnNewLineForFunctions': false,
                'placeOpenBraceOnNewLineForControlBlocks': false,
            },
        });
        if (response.body) {
            return response.body.map(e => utils_1.toTextEdit(e));
        }
        return [];
    }
    async onDefinition(params) {
        console.log('onDefinition js/ts');
        const path = language_core_1.uriToPath(params.textDocument.uri);
        const result = await this.tspClient.request("definition", {
            file: path,
            line: params.position.line + 1,
            offset: params.position.character + 1,
        });
        return result.body ? result.body
            .map(fileSpan => utils_1.toLocation(fileSpan)) : [];
    }
    async onCompletionResolve(item) {
        console.log('onCompletionResolve js/ts');
        const result = await this.tspClient.request("completionEntryDetails", {
            entryNames: [item.label],
            file: item.data.file,
            line: item.data.line,
            offset: item.data.offset,
        });
        if (!result.body) {
            return item;
        }
        if (result.body[0] && result.body[0].documentation) {
            item.documentation = result.body[0].documentation.map(i => i.text).join('\n');
        }
        return item;
    }
    async onCompletion(params) {
        console.log('onCompletion js/ts');
        const path = language_core_1.uriToPath(params.textDocument.uri);
        try {
            const result = await this.tspClient.request("completions", {
                file: path,
                line: params.position.line + 1,
                offset: params.position.character + 1,
                prefix: '',
            });
            return {
                isIncomplete: false,
                items: result.body ? result.body
                    .map(item => {
                    return {
                        label: item.name,
                        kind: utils_1.completionKindsMapping[item.kind],
                        data: {
                            file: path,
                            line: params.position.line + 1,
                            offset: params.position.character + 1,
                        },
                    };
                }) : [],
            };
        }
        catch (error) {
            console.log('error', error);
            return [];
        }
    }
    getOpenDocument(uri) {
        const doc = this.openedDocumentUris.get(uri);
        if (doc) {
            return doc;
        }
        else {
            throw new Error('Document ' + uri + ' has not been opened.');
        }
    }
};
JavascriptService = __decorate([
    inversify_1.injectable()
], JavascriptService);
exports.JavascriptService = JavascriptService;


/***/ }),

/***/ "./src/service/tsp-client.ts":
/*!***********************************!*\
  !*** ./src/service/tsp-client.ts ***!
  \***********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const cp = __webpack_require__(/*! child_process */ "child_process");
const readline = __webpack_require__(/*! readline */ "readline");
const decoder = __webpack_require__(/*! string_decoder */ "string_decoder");
class Deferred {
    constructor(operation, timeout) {
        this.operation = operation;
        this.promise = new Promise((resolve, reject) => {
            this.resolve = resolve;
            this.reject = reject;
        });
        setTimeout(() => {
            this.reject(new Error(this.operation + ' timeout'));
        }, timeout || 20000);
    }
}
exports.Deferred = Deferred;
class TspClient {
    constructor(options) {
        this.options = options;
        this.seq = 0;
        this.buffer = '';
        this.deferreds = {};
    }
    start() {
        if (this.readlineInterface) {
            return;
        }
        const args = [];
        console.log(`Starting tsserver : '${this.options.tsserverPath} ${args.join(' ')}'`);
        this.tsserverProc = cp.spawn(this.options.tsserverPath, args);
        this.readlineInterface = readline.createInterface(this.tsserverProc.stdout, this.tsserverProc.stdin, undefined);
        process.on('exit', () => {
            this.readlineInterface.close();
            this.tsserverProc.stdin.destroy();
            this.tsserverProc.kill();
        });
        this.readlineInterface.on('line', line => this.processMessage(line));
        const dec = new decoder.StringDecoder('utf-8');
        this.tsserverProc.stderr.addListener('data', data => {
            const stringMsg = typeof data === 'string' ? data : dec.write(data);
        });
    }
    notify(command, args) {
        this.sendMessage(command, true, args);
    }
    request(command, args) {
        return this.sendMessage(command, false, args);
    }
    sendMessage(command, notification, args) {
        this.seq = this.seq + 1;
        let request = {
            command,
            seq: this.seq,
            type: 'request',
        };
        if (args) {
            request.arguments = args;
        }
        const serializedRequest = JSON.stringify(request) + '\n';
        console.log('serializedRequest', serializedRequest);
        this.tsserverProc.stdin.write(serializedRequest);
        if (notification) {
            return;
        }
        else {
            return (this.deferreds[this.seq] = new Deferred(command)).promise;
        }
    }
    processMessage(untrimmedMessageString) {
        const messageString = untrimmedMessageString.trim();
        if (!messageString || messageString.startsWith('Content-Length:')) {
            return;
        }
        const message = JSON.parse(messageString);
        if (this.isResponse(message)) {
            this.resolveResponse(message, message.request_seq, message.success);
        }
        else if (this.isEvent(message)) {
            if (this.isRequestCompletedEvent(message)) {
                this.resolveResponse(message, message.body.request_seq, true);
            }
            else {
                if (this.options.onEvent) {
                    this.options.onEvent(message);
                }
            }
        }
    }
    resolveResponse(message, request_seq, success) {
        const deferred = this.deferreds[request_seq];
        if (deferred) {
            if (success) {
                this.deferreds[request_seq].resolve(message);
            }
            else {
                this.deferreds[request_seq].reject(message);
            }
            delete this.deferreds[request_seq];
        }
    }
    isEvent(message) {
        return message.type === 'event';
    }
    isResponse(message) {
        return message.type === 'response';
    }
    isRequestCompletedEvent(message) {
        return this.isEvent(message) && message.event === 'requestCompleted';
    }
}
exports.TspClient = TspClient;


/***/ }),

/***/ "./src/typescript/index.ts":
/*!*********************************!*\
  !*** ./src/typescript/index.ts ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const server_core_1 = __webpack_require__(/*! @common-stack/server-core */ "@common-stack/server-core");
const service_1 = __webpack_require__(/*! ../service */ "./src/service/index.ts");
const javascriptService = new service_1.JavascriptService();
exports.default = new server_core_1.Feature({
    createContextFunc: () => ({ javascript: javascriptService, typescript: javascriptService }),
});


/***/ }),

/***/ "./src/utils/index.ts":
/*!****************************!*\
  !*** ./src/utils/index.ts ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(/*! ./modules-resolver */ "./src/utils/modules-resolver.ts"));


/***/ }),

/***/ "./src/utils/modules-resolver.ts":
/*!***************************************!*\
  !*** ./src/utils/modules-resolver.ts ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const fs = __webpack_require__(/*! fs */ "fs");
const paths = __webpack_require__(/*! path */ "path");
const lsp = __webpack_require__(/*! vscode-languageserver */ "vscode-languageserver");
const language_core_1 = __webpack_require__(/*! @workbench-stack/language-core */ "@workbench-stack/language-core");
function findPathToModule(dir, moduleName) {
    const stat = fs.statSync(dir);
    if (stat.isDirectory()) {
        const candidate = paths.resolve(dir, 'node_modules', moduleName);
        if (fs.existsSync(candidate)) {
            return candidate;
        }
    }
    const parent = paths.resolve(dir, '..');
    if (parent !== dir) {
        return findPathToModule(paths.resolve(dir, '..'), moduleName);
    }
    return undefined;
}
exports.findPathToModule = findPathToModule;
function toPosition(location) {
    return {
        line: location.line - 1,
        character: location.offset - 1,
    };
}
exports.toPosition = toPosition;
function toLocation(fileSpan) {
    return {
        uri: language_core_1.pathToUri(fileSpan.file),
        range: {
            start: toPosition(fileSpan.start),
            end: toPosition(fileSpan.end),
        },
    };
}
exports.toLocation = toLocation;
exports.completionKindsMapping = {
    class: lsp.CompletionItemKind.Class,
    constructor: lsp.CompletionItemKind.Constructor,
    enum: lsp.CompletionItemKind.Enum,
    field: lsp.CompletionItemKind.Field,
    file: lsp.CompletionItemKind.File,
    function: lsp.CompletionItemKind.Function,
    interface: lsp.CompletionItemKind.Interface,
    keyword: lsp.CompletionItemKind.Keyword,
    method: lsp.CompletionItemKind.Method,
    module: lsp.CompletionItemKind.Module,
    property: lsp.CompletionItemKind.Property,
    reference: lsp.CompletionItemKind.Reference,
    snippet: lsp.CompletionItemKind.Snippet,
    text: lsp.CompletionItemKind.Text,
    unit: lsp.CompletionItemKind.Unit,
    value: lsp.CompletionItemKind.Value,
    variable: lsp.CompletionItemKind.Variable,
};
const symbolKindsMapping = {
    'enum member': lsp.SymbolKind.Constant,
    'JSX attribute': lsp.SymbolKind.Property,
    'local class': lsp.SymbolKind.Class,
    'local function': lsp.SymbolKind.Function,
    'local var': lsp.SymbolKind.Variable,
    'type parameter': lsp.SymbolKind.Variable,
    alias: lsp.SymbolKind.Variable,
    class: lsp.SymbolKind.Class,
    const: lsp.SymbolKind.Constant,
    constructor: lsp.SymbolKind.Constructor,
    enum: lsp.SymbolKind.Enum,
    field: lsp.SymbolKind.Field,
    file: lsp.SymbolKind.File,
    function: lsp.SymbolKind.Function,
    getter: lsp.SymbolKind.Method,
    interface: lsp.SymbolKind.Interface,
    let: lsp.SymbolKind.Variable,
    method: lsp.SymbolKind.Method,
    module: lsp.SymbolKind.Module,
    parameter: lsp.SymbolKind.Variable,
    property: lsp.SymbolKind.Property,
    setter: lsp.SymbolKind.Method,
    var: lsp.SymbolKind.Variable,
};
function toSymbolKind(tspKind) {
    return symbolKindsMapping[tspKind] || lsp.SymbolKind.Variable;
}
exports.toSymbolKind = toSymbolKind;
function toDiagnosticSeverity(category) {
    switch (category) {
        case 'error': return lsp.DiagnosticSeverity.Error;
        case 'warning': return lsp.DiagnosticSeverity.Warning;
        default: return lsp.DiagnosticSeverity.Information;
    }
}
exports.toDiagnosticSeverity = toDiagnosticSeverity;
function toDiagnostic(tspDiag) {
    return {
        range: {
            start: toPosition(tspDiag.start),
            end: toPosition(tspDiag.end),
        },
        message: tspDiag.text,
        severity: toDiagnosticSeverity(tspDiag.category),
        code: tspDiag.code,
        source: 'typescript',
    };
}
exports.toDiagnostic = toDiagnostic;
function toTextEdit(edit) {
    return {
        range: {
            start: toPosition(edit.start),
            end: toPosition(edit.end),
        },
        newText: edit.newText,
    };
}
exports.toTextEdit = toTextEdit;
function toPlainText(parts) {
    return parts.map(part => part.text).join('');
}
exports.toPlainText = toPlainText;
function tagsMarkdownPreview(tags) {
    return (tags || [])
        .map(tag => {
        const label = `*@${tag.name}*`;
        if (!tag.text) {
            return label;
        }
        return label + (tag.text.match(/\r\n|\n/g) ? '  \n' + tag.text : ` — ${tag.text}`);
    })
        .join('  \n\n');
}
function toMarkDown(documentation, tags) {
    let result = '';
    result += toPlainText(documentation);
    const tagsPreview = tagsMarkdownPreview(tags);
    if (tagsPreview) {
        result += '\n\n' + tagsPreview;
    }
    return result;
}
exports.toMarkDown = toMarkDown;
function toTextDocumentEdit(change) {
    return {
        textDocument: {
            uri: language_core_1.pathToUri(change.fileName),
            version: 0,
        },
        edits: change.textChanges.map(c => toTextEdit(c)),
    };
}
exports.toTextDocumentEdit = toTextDocumentEdit;
function toDocumentHighlight(item) {
    return item.highlightSpans.map(i => {
        return {
            kind: toDocumentHighlightKind(i.kind),
            range: {
                start: toPosition(i.start),
                end: toPosition(i.end),
            },
        };
    });
}
exports.toDocumentHighlight = toDocumentHighlight;
var HighlightSpanKind;
(function (HighlightSpanKind) {
    HighlightSpanKind["none"] = "none";
    HighlightSpanKind["definition"] = "definition";
    HighlightSpanKind["reference"] = "reference";
    HighlightSpanKind["writtenReference"] = "writtenReference";
})(HighlightSpanKind || (HighlightSpanKind = {}));
function toDocumentHighlightKind(kind) {
    switch (kind) {
        case HighlightSpanKind.definition: return lsp.DocumentHighlightKind.Write;
        case HighlightSpanKind.reference:
        case HighlightSpanKind.writtenReference: return lsp.DocumentHighlightKind.Read;
        default: return lsp.DocumentHighlightKind.Text;
    }
}


/***/ }),

/***/ "@common-stack/server-core":
/*!********************************************!*\
  !*** external "@common-stack/server-core" ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@common-stack/server-core");

/***/ }),

/***/ "@workbench-stack/language-core":
/*!*************************************************!*\
  !*** external "@workbench-stack/language-core" ***!
  \*************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/language-core");

/***/ }),

/***/ "child_process":
/*!********************************!*\
  !*** external "child_process" ***!
  \********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("child_process");

/***/ }),

/***/ "fs":
/*!*********************!*\
  !*** external "fs" ***!
  \*********************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("fs");

/***/ }),

/***/ "inversify":
/*!****************************!*\
  !*** external "inversify" ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("inversify");

/***/ }),

/***/ "path":
/*!***********************!*\
  !*** external "path" ***!
  \***********************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("path");

/***/ }),

/***/ "readline":
/*!***************************!*\
  !*** external "readline" ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("readline");

/***/ }),

/***/ "string_decoder":
/*!*********************************!*\
  !*** external "string_decoder" ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("string_decoder");

/***/ }),

/***/ "vscode-languageserver":
/*!****************************************!*\
  !*** external "vscode-languageserver" ***!
  \****************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("vscode-languageserver");

/***/ })

/******/ });
//# sourceMappingURL=index.js.map